<template>
	<section-search @searchData="searchData" @clearData="clearData"
		:search_params="commomParams.search"></section-search>
	<a-c-operation @refresh="clearData"></a-c-operation>
	<a-c-table :data="commomParams.table.data" :columns="commomParams.table.columns" :pagination="commomParams.page"
		@page="getPage" :loading="loading">
		<template #image="{ record }">
			<image-container :need="true" :imgObj="{src: imageprefix + record.cover_img,width: '50px',height: '50px', mode: 'fill'}"></image-container>
		</template>
		<template #default="{ record }">
			<a-row :gutter="10">
				<a-col><a-button type="primary" size="small" primary @click="edit(record)">编辑</a-button></a-col>
				<a-popconfirm title="是否删除该栏目/频道?" @confirm="del(record.id)">
					<a-col><a-button danger size="small" primary>删除</a-button></a-col>
				</a-popconfirm>
			</a-row>
		</template>
	</a-c-table>
	<section-add :edit_record="edit_record" @successAdd="successAdd" @closeAdd="closeAdd"></section-add>
</template>

<script lang="ts" setup>
	import { ref, onMounted, watch, computed } from 'vue';
	import SectionSearch from '@/views/information/section/search/index.vue';
	import SectionAdd from '@/views/information/section/add/add.vue';
	import { delSection, listSection } from '@/apis/models';
	import { useCommon } from '@/hooks/useCommon';
	import { cols } from '@/views/information/section/columns';
	import { message } from 'ant-design-vue';
	let { store, commomParams, showModal, showOtherModal1, imageprefix } = useCommon();
	let loading = ref<Boolean>(true);
	onMounted(() => {
		getData(commomParams.value.search);
	})

	const searchData = (data : object) => {
		commomParams.value.search = data
		getData();
	}

	const clearData = (data : object) => {
		commomParams.value.search = {
			page: 1,
			pagesize: 10,
			sort: 'id',
			sortby: 'desc',
			keyword: ''
		}
		getData();
	}


	const getPage = (data : object) => {
		commomParams.value.search.page = data.current;
		commomParams.value.search.pagesize = data.pageSize;
		getData();
	}
	const getData = async () => {
		try {
			loading.value = true;
			let res = await listSection(commomParams.value.search);

			loading.value = false;
			commomParams.value.table.data = res.data.sections;
			commomParams.value.table.columns = cols;
			commomParams.value.page = {
				current: commomParams.value.search.page,
				pageSize: commomParams.value.search.pagesize,
				total: res.data.total,
				pageSizeOptions: ['10', '20', '30', '40'],
				hideOnSinglePage: false,
				showSizeChanger: true
			};
		} catch (err) {
			loading.value = false;
		}
	}


	// 编辑
	let edit_record = ref<Object>(null)
	const edit = (record : object) => {
		edit_record.value = record;
		showModal()
	}
	const successAdd = () => {
		getData();
	}
	const closeAdd = () => {
		edit_record.value = null;
	}

	// 删除
	const del = (id: number) => {
		commomParams.value.delRecord = { id: id };
		delSection(commomParams.value.delRecord).then(res => {
			message.success('删除成功');
			getData();
		})
	}
</script>

<style lang="less" scoped>

</style>